#pragma once
/****************************************************************************
* NVMC                                                                      *
* Visual and Computer Graphics Library                                      *
*                                                                           *
* Copyright(C) 2007                                                         *
* ISTI - Italian National Research Council                                  *
*                                                                           *
* All rights reserved.                                                      *
*                                                                           *
* This program is free software; you can redistribute it and/or modify      *   
* it under the terms of the GNU General Public License as published by      *
* the Free Software Foundation; either version 2 of the License, or         *
* (at your option) any later version.                                       *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License (http://www.gnu.org/licenses/gpl.txt)          *
* for more details.                                                         *
*                                                                           *
****************************************************************************/
/****************************************************************************
  History

$Log: game_client.h,v $
Revision 1.4  2007/04/09 23:08:41  ganovelli
added standalone mode

Revision 1.3  2007/03/29 21:52:44  ganovelli
added builder of circuits.

Revision 1.2  2007/03/11 18:11:59  ganovelli
minor modif

*****************************************************************************/

#include <race.h>
#include "simple_circuit_creator.h"
#include <messages.h>

///
struct NvmcClient{

///
std::vector<Circuit> circuits;

/** start up the game client */
int Initialize(char * circuitFile,bool standalone);

/** start the main loop */
int Start();

/** close the client  */
int Terminate();

/** post a command */
int Command(C2SHeaderValue value);

/** copy of race.players made by UpdatePlayers */ 
Race::PlayerContainer players;

/** makes a copy of race.players (accessed by the receiver thread */
void UpdatePlayers();

/** messages to send to the  server*/
std::vector<pt::string> messagesToSend;


/** mutex on  messagesToSend	 */
pt::mutex  mutex_on_messagesToSend;
};

///
extern NvmcClient cli;