#pragma once
/****************************************************************************
*                                                                           *
* Copyright(C) 2007                                                         *
* Pierluigi Failla                                                          *
*																			*
* http://www.zeta.xm.com													*
*                                                                           *
* All rights reserved.                                                      *
*                                                                           *
* This program is free software; you can redistribute it and/or modify      *   
* it under the terms of the GNU General Public License as published by      *
* the Free Software Foundation; either version 2 of the License, or         *
* (at your option) any later version.                                       *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License (http://www.gnu.org/licenses/gpl.txt)          *
* for more details.                                                         *
*                                                                           *
****************************************************************************/

#include <GL/glew.h>

#include <vcg/space/point3.h>

#include "Lens.h"

using namespace vcg;

/*
Enjoy lens flares :)))))))))
*/
//settings one flare
void Flare::SetFlare(GLuint Texture, float Location, float Scaling, float Col[3], float ColorScale){
	Tex = Texture;
	Loc = Location;
	Scale = Scaling;
	Color[0] = Col[0] * ColorScale;
	Color[1] = Col[1] * ColorScale;
	Color[2] = Col[2] * ColorScale;
}

/*
Flares!!!!!!!!!!!!!!!!!!!!!!! (ci proviamo!!!)
*/
Flares::Flares(void){ //costruttore base 1 solo flare
	TOT_FLARES = 1;
	F = new Flare[TOT_FLARES];
	G_Scale = 1.5;
}
Flares::Flares(int NumFlares){ //overload costruttore
	TOT_FLARES = NumFlares;
	F = new Flare[TOT_FLARES];
	G_Scale = 1.5;
}
void Flares::DoFlares(vcg::Point3f From, vcg::Point3f At, vcg::Point3f LightPosition, float NearClipPlane){
	vcg::Point3f ViewDirection = At-From; ViewDirection.Normalize();
	vcg::Point3f Center = From + ViewDirection * NearClipPlane;
	vcg::Point3f LightDirection = LightPosition - From; LightDirection.Normalize();
	LightPosition = From + LightDirection * ((LightPosition * ViewDirection) * NearClipPlane);
	vcg::Point3f Axis = LightPosition - Center;
	vcg::Point3f dx = Axis.Normalize();
	vcg::Point3f dy = dx ^ ViewDirection;

	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE, GL_ONE);

	glEnable (GL_TEXTURE_2D);

	for(int i=0; i<TOT_FLARES; i++){
		vcg::Point3f sx = dx * F[i].Scale * G_Scale;
		vcg::Point3f sy = dy * F[i].Scale * G_Scale;

		glColor3fv(F[i].Color);
		glBindTexture(GL_TEXTURE_2D, F[i].Tex);

		vcg::Point3f Position = Center + Axis * F[i].Loc;
		vcg::Point3f tmp;

		glBegin(GL_QUADS);
			glTexCoord2f(0.0, 0.0);
			tmp = Position + sx + sy;
			glVertex3f(tmp[0],tmp[1],tmp[2]);

			glTexCoord2f(1.0, 0.0);
			tmp = Position - sx + sy;
			glVertex3f(tmp[0],tmp[1],tmp[2]);

			glTexCoord2f(1.0, 1.0);
			tmp = Position - sx - sy;
			glVertex3f(tmp[0],tmp[1],tmp[2]);

			glTexCoord2f(0.0, 1.0);
			tmp = Position + sx - sy;
			glVertex3f(tmp[0],tmp[1],tmp[2]);
		glEnd();
	}
	glEnable(GL_DEPTH_TEST);
	glDisable(GL_BLEND);
	glDisable (GL_TEXTURE_2D);
}