/****************************************************************************
* NVMC                                                                      *
* Visual and Computer Graphics Library                                      *
*                                                                           *
* Copyright(C) 2007                                                         *
* ISTI - Italian National Research Council                                  *
*                                                                           *
* All rights reserved.                                                      *
*                                                                           *
* This program is free software; you can redistribute it and/or modify      *   
* it under the terms of the GNU General Public License as published by      *
* the Free Software Foundation; either version 2 of the License, or         *
* (at your option) any later version.                                       *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License (http://www.gnu.org/licenses/gpl.txt)          *
* for more details.                                                         *
*                                                                           *
****************************************************************************/
/****************************************************************************
  History

$Log: game_viewer.cpp,v $
Revision 1.15  2007/05/13 09:43:42  samueleforconi
*** empty log message ***

Revision 1.14  2007/05/13 09:35:13  samueleforconi
*** empty log message ***

Revision 1.13  2007/05/10 22:58:01  samueleforconi
*** empty log message ***

Revision 1.12  2007/05/02 22:53:54  samueleforconi
*** empty log message ***

Revision 1.11  2007/05/02 21:41:08  samueleforconi
*** empty log message ***

Revision 1.10  2007/04/28 08:56:27  samueleforconi
*** empty log message ***

Revision 1.8  2007/04/26 08:17:32  samueleforconi
*** empty log message ***

Revision 1.7  2007/04/25 15:32:06  samueleforconi
*** empty log message ***

Revision 1.6  2007/04/25 08:36:56  samueleforconi
*** empty log message ***

Revision 1.5  2007/04/20 14:07:48  samueleforconi
*** empty log message ***

Revision 1.4  2007/04/19 16:54:21  samueleforconi
*** empty log message ***

Revision 1.3  2007/04/19 11:35:59  samueleforconi
*** empty log message ***

Revision 1.2  2007/04/16 22:20:08  samueleforconi
*** empty log message ***

Revision 1.6  2007/04/04 13:30:14  samueleforconi
*** empty log message ***

Revision 1.5  2007/04/03 19:14:19  samueleforconi
*** empty log message ***

Revision 1.4  2007/04/03 10:02:45  samueleforconi
*** empty log message ***

Revision 1.3  2007/04/02 18:15:08  samueleforconi
*** empty log message ***

Revision 1.2  2007/04/02 16:46:08  samueleforconi
*** empty log message ***

Revision 1.1  2007/03/27 08:21:10  samueleforconi
client3 - cubemapping

Revision 1.3  2007/03/11 18:11:59  ganovelli
minor modif


****************************************************************************/

#include <SDL.h>
#include <GL/glew.h>
#include <math.h>
#include <time.h>
#include <vcg/space/point3.h>
#include <vector>
#include <GL/glut.h>
#include <GL/glu.h>


//include x load modello mesh .ply
#include <vcg/simplex/vertexplus/base.h>
#include <vcg/simplex/faceplus/base.h>
#include <vcg/complex/trimesh/base.h>
#include <vcg/complex/trimesh/update/bounding.h>
#include <vcg/complex/trimesh/update/normal.h>
#include <wrap/io_trimesh/import.h>
#include <wrap/gl/trimesh.h>


#include "../client/game_client.h"
#include <wrap/gui/trackball.h>
#include "game_viewer.h"
#include "race.h"

#include "myfunctions.h"
#include "tga.h"
#include "Lens.h"
#include "thecar.h"

/** Client  */
extern  NvmcClient cli;
/* value of pi */
#define M_PI       3.14159265358979323846
/** viewport size */
int width,height;
/* valori per il lighting */
GLfloat mat_lig[32];
/* rotazione della ruota */
float alpha_wheel=0, d_alpha_wheel=0;
/* sole */
vcg::Point4f spotdir;
//GLfloat sole[4] = {0.0,100.0,0.0,1.0};
GLfloat sole[4];
/* variabili ppr la rotazione con trackball */
int x_0,y_0,x_1,y_1;
/* guardia che vale true se un bottone del mouse e' premuto */
bool mouse_BLDown = false;
/* guardia che value true quando il moviemento del mouse determina la rotazione */
bool rotate = false;
/* Rotazione con trackball */
/* angolo di rotazione */
float rot_angle;
/* asse di rotazione */
vcg::Point3d rot_axis;
/* matrice di rotazione */
double rot_mat[16]={ 1,0,0,0 , 0,1,0,0 , 0,0,1,0 , 0,0,0,1 };

bool c_up, c_down, c_left, c_right;
float cam_x = 0, cam_y = 0, cam_z = 0;

#define circuito_tex "../../client3/textures/circuito.bmp"
#define circuito_bind 1
#define erba_tex "../../client3/textures/erba1a.bmp"
#define erba_bind 2
#define palazzo_tex "../../client3/textures/palazzo3a.bmp"
#define palazzo_bind 3
#define flare1_tex "../../client3/textures/Flare1.tga"
#define flare1_bind 10
#define flare2_tex "../../client3/textures/Flare2.tga"
#define flare2_bind 11
#define flare3_tex "../../client3/textures/Flare3.tga"
#define flare3_bind 12
#define albero_tex "../../client3/textures/albero.tga"
#define albero_bind 13
#define lamp_tex "../../client3/textures/lamp3.tga"
#define lamp_bind 14

vcg::Point3f pov      = vcg::Point3f(0,0,0);
vcg::Point3f target   = vcg::Point3f(0,0,0);
vcg::Point3f bmin;
vcg::Point3f bmax;

GLuint circuito;
GLuint palazzi;
GLuint macchina;

bool DYNAMIC_CUBE_MAP = false;
bool LENS_FLARE = false;
bool MOTION_BLUR = false;
bool HELP = false;
bool LAMP = false;
bool INCAR = false;

Flares *Fl;

int ZOOM = 60;
int UPDOWN = 5;
int ROT = 0;

// INIZIALIZZA LE LUCI
void init_lights(){
	// ENABLE LIGHTING
	glEnable(GL_LIGHTING);
	// SOLE
	glEnable(GL_LIGHT0);
	// FARI
	glEnable(GL_LIGHT1);
	glEnable(GL_LIGHT2);

	int	i;
	//MATERIALE
	for(i=0; i < 4; ++i) mat_lig[i]=0.0; //EMISSIVA
	for(i=4; i < 8; ++i) mat_lig[i]=0.4; //AMBIENTE
	for(i=8; i < 12; ++i) mat_lig[i]=0.6; //DIFFUSA
	for(i=12; i < 16; ++i) mat_lig[i]=0.4; //SPECULARE

	for(i=16; i < 20; ++i) mat_lig[i]=1.0; //EMISSIVA
	for(i=20; i < 24; ++i) mat_lig[i]=0.4; //AMBIENTE
	for(i=24; i < 28; ++i) mat_lig[i]=0.6; //DIFFUSA
	for(i=28; i < 32; ++i) mat_lig[i]=0.4; //SPECULARE
}

// SETTA LE IMPOSTAZIONI DELL'ILLUMINAZIONE
void set_lights(){
	/* SETTA I PARAMETRI DEL MATERIALE */
	glMaterialfv(GL_FRONT,GL_EMISSION, &mat_lig[0]);
	glMaterialfv(GL_FRONT,GL_AMBIENT, &mat_lig[4]);
	glMaterialfv(GL_FRONT,GL_DIFFUSE, &mat_lig[8]);
	glMaterialfv(GL_FRONT,GL_SPECULAR, &mat_lig[12]);
	glMaterialf(GL_FRONT,GL_SHININESS,100); 

	/* setta i parametri della luce */
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT,&mat_lig[16]);

	//ligth0
	glLightfv(GL_LIGHT0,GL_AMBIENT,  &mat_lig[20]);
	glLightfv(GL_LIGHT0,GL_DIFFUSE,  &mat_lig[24]);
	glLightfv(GL_LIGHT0,GL_SPECULAR, &mat_lig[28]);

    //faro 1
	glLightfv(GL_LIGHT1,GL_AMBIENT,  &mat_lig[20]);
	glLightfv(GL_LIGHT1,GL_DIFFUSE,  &mat_lig[24]);
	glLightfv(GL_LIGHT1,GL_SPECULAR, &mat_lig[28]);

	glLighti(GL_LIGHT1,GL_SPOT_EXPONENT, 110 );
	glLightf(GL_LIGHT1,GL_SPOT_CUTOFF, 50 );

    glLightf (GL_LIGHT1, GL_LINEAR_ATTENUATION,    0.01f);
    glLightf (GL_LIGHT1, GL_QUADRATIC_ATTENUATION, 0.0f);
    glLightf (GL_LIGHT1, GL_CONSTANT_ATTENUATION,  0.0);

    //faro2
    glLightfv(GL_LIGHT2,GL_AMBIENT,  &mat_lig[20]);
	glLightfv(GL_LIGHT2,GL_DIFFUSE,  &mat_lig[24]);
	glLightfv(GL_LIGHT2,GL_SPECULAR, &mat_lig[28]);
        
	glLighti(GL_LIGHT2,GL_SPOT_EXPONENT, 110 );
	glLightf(GL_LIGHT2,GL_SPOT_CUTOFF, 50 );
        
    glLightf (GL_LIGHT2, GL_LINEAR_ATTENUATION,    0.01f);
    glLightf (GL_LIGHT2, GL_QUADRATIC_ATTENUATION, 0.0f);
    glLightf (GL_LIGHT2, GL_CONSTANT_ATTENUATION,  0.0);
}

//INIZIALIZZA IL FLARE
float red[3] = {1.0, 0.0, 0.0};
float green[3] = {0.0, 1.0, 0.0};
float blue[3] = {0.0, 0.0, 1.0};
float white[3] = {1,1,1};
void init_flares(void){
	Fl = new Flares(8);
	Fl->F[0].SetFlare(flare1_bind,1.5,0.1,red,0.4);
	Fl->F[1].SetFlare(flare3_bind,0.8,0.12,white,0.5);
	Fl->F[2].SetFlare(flare2_bind,0.4,0.09,white,0.3);
	Fl->F[3].SetFlare(flare2_bind,0.7,0.08,white,0.3);
	Fl->F[4].SetFlare(flare3_bind,1.1,0.2,blue,0.2);
	Fl->F[5].SetFlare(flare1_bind,1.2,0.18,green,0.4);
	Fl->F[6].SetFlare(flare2_bind,1.7,0.08,white,0.2);
	Fl->F[7].SetFlare(flare2_bind,1.85,0.06,white,0.4);
}


char *faceFile_alternative[6] = {
  "../../client3/cubemap/Right_night2.bmp", 
  "../../client3/cubemap/Left_night2.bmp", 
  "../../client3/cubemap/Top_night2.bmp", 
  "../../client3/cubemap/Bottom_night2.bmp", 
  "../../client3/cubemap/Back_night2.bmp", 
  "../../client3/cubemap/Front_night2.bmp", 
};


int faceBind[6] = {4,5,6,7,8,9};

// INIZIALIZZAZIONE STATO OPENGL
void init_opengl(){
	// RASTERIZZA POLIGONI
	glPolygonMode(GL_FRONT,GL_FILL);
	// DEPTH BUFFER
	glEnable(GL_DEPTH_TEST);

	// CARICO LE TEXTURE DA IMMAGINI BMP (B-G-R)
	GLuint tex1 = LoadTextureBMP(circuito_tex, circuito_bind, GL_TRUE, GL_FALSE);
	GLuint tex2 = LoadTextureBMP(erba_tex, erba_bind, GL_TRUE, GL_FALSE);
	GLuint tex4 = LoadTextureBMP(palazzo_tex, palazzo_bind, GL_TRUE, GL_FALSE);

	int i;
	for (i=0; i<6; i++) {
		// CARICO LE TEXTURE
		LoadTextureBMP(faceFile_alternative[i], faceBind[i], GL_TRUE, GL_FALSE);		
	}

	tgaInfo *tgaFile;
	
	//ALBERO
	tgaFile = tgaLoad(albero_tex);
    glBindTexture(GL_TEXTURE_2D,albero_bind);
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_WRAP_S,	GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_WRAP_T,	GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_MAG_FILTER	,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_MIN_FILTER	,GL_LINEAR);	
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, tgaFile->width, tgaFile->height, 0, GL_RGBA, GL_UNSIGNED_BYTE, tgaFile->imageData);

	//FLARE1
	tgaFile = tgaLoad(flare1_tex);
	glBindTexture( GL_TEXTURE_2D, flare1_bind );
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_WRAP_S,	GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_WRAP_T,	GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_MAG_FILTER	,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_MIN_FILTER	,GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, tgaFile->width, tgaFile->height, 0, GL_RGBA, GL_UNSIGNED_BYTE, tgaFile->imageData);

	//FLARE2
	tgaFile = tgaLoad(flare2_tex);
	glBindTexture( GL_TEXTURE_2D, flare2_bind );
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_WRAP_S,	GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_WRAP_T,	GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_MAG_FILTER	,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_MIN_FILTER	,GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, tgaFile->width, tgaFile->height, 0, GL_RGBA, GL_UNSIGNED_BYTE, tgaFile->imageData);

	//FLARE3
	tgaFile = tgaLoad(flare3_tex);
	glBindTexture( GL_TEXTURE_2D, flare3_bind );
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_WRAP_S,	GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_WRAP_T,	GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_MAG_FILTER	,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_MIN_FILTER	,GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, tgaFile->width, tgaFile->height, 0, GL_RGBA, GL_UNSIGNED_BYTE, tgaFile->imageData);

	//LAMPIONE
	tgaFile = tgaLoad(lamp_tex);
	glBindTexture( GL_TEXTURE_2D, lamp_bind );
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_WRAP_S,	GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_WRAP_T,	GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_MAG_FILTER	,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,	GL_TEXTURE_MIN_FILTER	,GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, tgaFile->width, tgaFile->height, 0, GL_RGBA, GL_UNSIGNED_BYTE, tgaFile->imageData);

	// CARICA LA MESH DELLA MACCHINA
	loadCar();

	// INIZIALIZZA LE LUCI
	init_lights();

	//DISPLAY LISTS
	circuito = glGenLists(1);
	glNewList(circuito, GL_COMPILE);
		draw_circuito();
	glEndList();

	palazzi = glGenLists(1);
	glNewList(palazzi, GL_COMPILE);
		draw_palazzi();
	glEndList();

	macchina = genCar();
}

// CALLBACK PER IL RESIZE SCREEN
void resize_screen(int w, int h){
	width = w;
	height = h;
	glViewport(0,0,width,height);
}

// DISEGNA ASSI
void draw_axis(){

	glPushAttrib(0xffffffff);
	glDisable(GL_LIGHTING);
	glBegin(GL_LINES);
	glColor3f(1.0,0.0,0.0);
  glVertex3f(0,0,0); //   X
  glVertex3f(10,0,0); 
  
	glColor3f(0.0,1.0,0.0);
  glVertex3f(0,0,0); //   Y
  glVertex3f(0,10,0);
  
	glColor3f(0.0,0.0,1.0);
  glVertex3f(0,0,0); //   Z
  glVertex3f(0,0,10);
  glEnd();
 	glPopAttrib();
}


// TRASCINAMENTO MOUSE
void muovi_track(){
		int vp[4];
		double pm[16],mm[16];
		vcg::Point3d res0,res1,ax;

		/* con le seguenti 3 chiamate recupera le matrici di modello e proiezione e il valore della viewport */
		glGetIntegerv(GL_VIEWPORT,vp);
		glGetDoublev(GL_MODELVIEW_MATRIX,mm);
		glGetDoublev(GL_PROJECTION_MATRIX,pm);

		gluUnProject(x_0,vp[3]-y_0,0.0,mm,pm,vp,&res0[0],&res0[1],&res0[2]);
		gluUnProject(x_1,vp[3]-y_1,0.0,mm,pm,vp,&res1[0],&res1[1],&res1[2]);

		ax = res0^res1;

		/* calcolo dell'angolo di rotazione */
		rot_angle = 360/M_PI*asin(ax.Norm()/(res0.Norm()*res1.Norm()));
		rot_axis = ax;
		
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();		// metti in salvo la matrice corrente nello stack 
		glLoadIdentity();	// metti la matrice modelview a matrice unitaria

		/* applica la rotazione appena calcolata */ 
		glRotatef( 10*rot_angle,rot_axis[0],rot_axis[1],rot_axis[2]); 

		/* applica la rotazione corrente */ 
		glMultMatrixd(rot_mat);						

		/* ora come matrice di modello abbiamo la composizione della rotazione corrente e della nuova rotazione apena fatta,
		non resta che rileggere la matrice di modello*/
		glGetDoublev(GL_MODELVIEW_MATRIX,rot_mat);

		glPopMatrix();	// torniamo alla matrice di modello precedente il glPushMatrix()
		rotate = false;	// non ripassare di qua fino al prossimo movimento del mouse
}



void cube_mapping_on(void){
	glEnable(GL_TEXTURE_GEN_S);
	glEnable(GL_TEXTURE_GEN_T);
	glEnable(GL_TEXTURE_GEN_R);  
	
	glEnable(GL_TEXTURE_CUBE_MAP);
	
	glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP_EXT);
	glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP_EXT);
	glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP_EXT);
}

void cube_mapping_off(){
   glDisable(GL_TEXTURE_GEN_S);
   glDisable(GL_TEXTURE_GEN_T);
   glDisable(GL_TEXTURE_GEN_R);
   glDisable(GL_TEXTURE_CUBE_MAP);	
}

// DISEGNA MACCHINA
void draw_giocatori(){
	Race::PlayersIterator pi;
	//int st = clock();
	for(pi = cli.players.begin(); pi != cli.players.end(); ++pi){
			glPushMatrix();
				/* apply transformation coded in the frame */
				Frame f = ((*pi).car.frame); 
				glMultMatrixf(&f[0][0]);
				glPushMatrix();
					glTranslatef(0.0,1.5,0.0);
					glCallList(macchina);
				glPopMatrix();
				//glColor3f(1.0,0.0,0.0);
				//gl_print(0.0,3.0,(*pi).ip_address.c_str()); // write the IP address of the client
			glPopMatrix();
	 }
}

// DISEGNA ALBERI
void draw_alberi(){
	glEnable(GL_TEXTURE_2D);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);
	glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
	glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER, 0);
	glBindTexture(GL_TEXTURE_2D, albero_bind);
	// ITERATORE SUGLI ALBERI
	Circuit::TreesIterator ti;
	for(ti=race.circuit->trees.begin();ti!=race.circuit->trees.end();++ti){
		glPushMatrix();
			// POSIZIONE ALBERO
			vcg::Point3f pos=(*ti).pos;
			// ALTEZZA ALBERO
			float height = (*ti).height;
			// PUNTO DI VISTA
			float cam[3]={pov[0],pov[1],pov[2]};
			// MI SPOSTO SULLA POSIZIONE DELL'ALBERO
			float treePos[3]={pos[0],pos[1],pos[2]};
			// DISEGNO ALBERI SOLO SE DAVANTI AL FAR
			float dist = (pov - pos).Norm();
			if(dist<750){
				glTranslatef(treePos[0],treePos[1],treePos[2]);
				billboard(cam, treePos);
				glBegin(GL_QUADS);
					glTexCoord2f(0,0);glVertex3f(-(height), 0.0f, 0.0f);
					glTexCoord2f(1,0);glVertex3f((height), 0.0f, 0.0f);
					glTexCoord2f(1,1);glVertex3f((height), height*2,  0.0f);
					glTexCoord2f(0,1);glVertex3f(-(height), height*2,  0.0f);
				glEnd();
			}

		glPopMatrix();
	}
	glDisable(GL_BLEND);
    glDisable(GL_ALPHA_TEST);
	glDisable(GL_TEXTURE_2D);	
}


void draw_lampioni(){
	glEnable(GL_TEXTURE_2D);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);
	glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_DST_COLOR);
    glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER, 0);
	glBindTexture(GL_TEXTURE_2D, lamp_bind);
	float eye[3]={pov[0],pov[1],pov[2]};
	float lampos[3];
	Street::TilesIterator ti;
	vcg::Point3f p0,p1;
	for(ti = race.circuit->street.path.begin(); ti != race.circuit->street.path.end();++ti){
		p0 = (*ti)[0].P(); 
		p1 = (*ti)[1].P();
		glPushMatrix();
			glTranslatef(p0[0],p0[1],p0[2]);
			glScalef(2,5,2);
			lampos[0] = p0[0];
			lampos[1] = p0[1];
			lampos[2] = p0[2];
			billboard(eye, lampos);
			glBegin(GL_QUADS);
				glNormal3f(0,0,1);
				glTexCoord2f(0,0);glVertex3f(-1.0,0.0,0.0);
				glTexCoord2f(1,0);glVertex3f( 1.0,0.0,0.0);
				glTexCoord2f(1,1);glVertex3f( 1.0,1.0,0.0);
				glTexCoord2f(0,1);glVertex3f(-1.0,1.0,0.0);
			glEnd();
		glPopMatrix();
		glPushMatrix();	
			glTranslatef(p1[0],p1[1],p1[2]);
			glScalef(2,5,2);
			lampos[0] = p1[0];
			lampos[1] = p1[1];
			lampos[2] = p1[2];
			billboard(eye, lampos);
			glBegin(GL_QUADS);
				glNormal3f(0,0,1);
				glTexCoord2f(0,0);glVertex3f(-1.0,0.0,0.0);
				glTexCoord2f(1,0);glVertex3f( 1.0,0.0,0.0);
				glTexCoord2f(1,1);glVertex3f( 1.0,1.0,0.0);
				glTexCoord2f(0,1);glVertex3f(-1.0,1.0,0.0);
			glEnd();
		glPopMatrix();
	}
	glDisable(GL_ALPHA_TEST);
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
}
//FILE * pFile;
void draw_scene(bool dyn_cm, int cubeside){
	static int cn = 0;
	static int part = 0;
	glClear(GL_DEPTH_BUFFER_BIT);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	set_lights();

	//moving sun!!!!
	for(int i=0; i<4; i++){sole[i] = race.circuit->sun_position[i];}
	glLightfv(GL_LIGHT0,GL_POSITION,sole);

	/* updte the state of the players as received by the server */
	cli.UpdatePlayers();

	Race::PlayersIterator fpi;
	vcg::Point3f position = vcg::Point3f(0,0,0);
	vcg::Point3f delta    = vcg::Point3f(0,0,0);
	
	fpi = cli.players.begin();

	Frame myf = (*fpi).car.frame;
	position  = myf.GetRow3(3);
	delta     = myf.GetRow3(2)*15 + myf.GetRow3(1)*UPDOWN;
	
	// LOOK AT
	if(!dyn_cm){			
		gluPerspective(ZOOM, width/(float)height, 1, 750);
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		pov = position + delta;
		//fprintf(pFile,"del_x=%f del_y=%f del_z=%f\n",&delta.X(),&delta.Y(),&delta.Z());
		//fprintf(pFile,"pos_x=%f pos_y=%f pos_z=%f\n",&position.X(),&position.Y(),&position.Z());
		//fprintf(pFile,"pov_x=%f pov_y=%f pov_z=%f\n",&pov.X(),&pov.Y(),&pov.Z());	
		gluLookAt(pov.X()+ROT,pov.Y()-1,pov.Z(),position.X(),position.Y(),position.Z(),0,1,0);
	} else {
		vcg::Point3f delta2 = vcg::Point3f(0,0,0);
		gluPerspective(90, width/(float)height, 0.1, 500);
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		switch(cubeside){
			case 0: 
				// POSITIVE_X
				delta2 = myf.GetRow3(0)*2;
				target = position + delta2;
				gluLookAt(position.X(),position.Y()+1,position.Z(), target.X(),target.Y(),target.Z(), 0,-1,0);
				break;
			case 1:
				// NEGATIVE_X
				delta2 = -myf.GetRow3(0)*2;
				target = position + delta2;
				gluLookAt(position.X(),position.Y()+1,position.Z(), target.X(),target.Y(),target.Z(), 0,-1,0);
				break;
			case 2:
				// POSITIVE_Y
				delta2 = myf.GetRow3(1)*2;
				target = position + delta2;
				gluLookAt(position.X(),position.Y()+1,position.Z(), target.X(),target.Y(),target.Z(), 0,0,1);
				break;
			case 3:
				// NEGATIVE_Y
				delta2 = -myf.GetRow3(1)*2;
				target = position + delta2;
				gluLookAt(position.X(),position.Y()+1,position.Z(), target.X(),target.Y(),target.Z(), 0,0,-1);
				break;
			case 4:
				// POSITIVE_Z
				delta2 = myf.GetRow3(2)*5;
				target = position + delta2;
				gluLookAt(position.X(),position.Y()+1,position.Z(), target.X(),target.Y(),target.Z(), 0,-1,0);
				break;
			case 5:
				// NEGATIVE_Z
				delta2 = -myf.GetRow3(2)*2;
				target = position + delta2;
				gluLookAt(position.X(),position.Y()+1,position.Z(), target.X(),target.Y(),target.Z(), 0,-1,0);
				break;
		}
	}

	// SPOSTAMENTO TRACKBALL CON MOUSE
	/*rotate vale true quando il mouse ha un bottone premuto e si  mosso */
	if(rotate){
		muovi_track();
	}
	glMultMatrixd(rot_mat);	// APPLICA IL MOVIMENTO TRACKBALL
		
	// SKYBOX
	glPushMatrix();
		glTranslatef(position.X(),position.Y()+50,position.Z());
		draw_skybox(0,0,0,400,100,400);
	glPopMatrix();

	// DISEGNA TERRENO E APPLICA LA TEXTURE ERBA
	draw_erba();

	// CIRCUITO
	glCallList(circuito);

	if(LAMP) draw_lampioni();
	
	// PALAZZI
	glCallList(palazzi);
	
	// ALBERI
	draw_alberi();
		
	// MACCHINA
	//NOTA: QUANDO FACCIO IL RENDERING PER LE TEXTURE DEL CUBE-MAP NON DISEGNO LA MACCHINA
	if(!dyn_cm && DYNAMIC_CUBE_MAP){
		// MACCHINA CON CUBE-MAPPING ATTIVO
		cube_mapping_on();
		draw_giocatori();
		cube_mapping_off();
	} else {
		//MACCHINA SENZA CUBE-MAPPING
		if(!dyn_cm && !DYNAMIC_CUBE_MAP)
			draw_giocatori();
	}
	
	
	
	// LENS FLARE
	if(!dyn_cm && LENS_FLARE){
		glDisable(GL_LIGHTING);
		vcg::Point3f from(pov.X(),pov.Y(),pov.Z());
		vcg::Point3f at(position.X(),position.Y(),position.Z());
		vcg::Point3f pos(sole[0],sole[1],sole[2]);
		Fl->DoFlares(from,at,pos,2);
		glEnable(GL_LIGHTING);
	}

	glLoadIdentity();
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	if(!dyn_cm){
		if(HELP){
		/* print the commands */
			gl_print(-1,0.8,"F1: DYN CUBE-MAP");
			gl_print(-1,0.7,"F2: MOTION BLUR");
			gl_print(-1,0.6,"F3: LENS FLARE");
			gl_print(-1,0.5,"F4: LAMPPOST");
			gl_print(-1,0.4,"Brake: x");
			gl_print(-1,0.3,"Reset: p");
			gl_print(-1,0.2,"Rotate car: r");
			gl_print(-1,0.1,"Zoom IN: n");
			gl_print(-1,0.0,"Zoom OUT: m");
			gl_print(-1,-0.1,"View up: Arrow UP");
			gl_print(-1,-0.2,"View Down: Arrow DOWN");
			gl_print(-1,-0.3,"View Left: Arrow LEFT");
			gl_print(-1,-0.4,"View Right: Arrow RIGHT");
		} else {
			gl_print(-1,0.8,"Press h for HELP");
		}
	}

	//SDL_GL_SwapBuffers();
	cn++;
	if(clock()-part >1000){	
		printf("VIEW fps %d\n",cn);
		part = clock();
		cn=0;
	}
}


void mouse_move(SDL_Event e){
	if(mouse_BLDown){
		rotate = true;
		x_0 = e.motion.x-e.motion.xrel;
		y_0 = e.motion.y-e.motion.yrel;
		x_1 = e.motion.x;
		y_1 = e.motion.y;
	}
}

//bool c_up, c_down, c_right, c_left;
void keydown(SDL_Event e){
	switch(e.key.keysym.sym){
		case SDLK_w: 
			c_up = true;
			break;
		case SDLK_s: 
			c_down = true;
			break;
		case SDLK_a: 
			c_left = true;
			break;
		case SDLK_d: 
			c_right = true;
			break;
		case SDLK_x: 
			cli.Command(COMMAND_BRAKE);
			break;
		case SDLK_p: 
			cli.Command(COMMAND_RESTART);
			break;
		case SDLK_m:
			ZOOM += 5;
			break;
		case SDLK_n:
			ZOOM -= 5;
			break;
		case SDLK_h:
			HELP = HELP ? false : true;
			break;
		case SDLK_UP:
			UPDOWN += 1;
			break;
		case SDLK_DOWN:
			UPDOWN -= 0.5;
			break;
		case SDLK_LEFT:
			ROT -= 1;
			break;
		case SDLK_RIGHT:
			ROT += 1;
			break;
		case SDLK_F1:
			//DYNAMIC CUBEMAP
			if(DYNAMIC_CUBE_MAP){
				DYNAMIC_CUBE_MAP  = false;
			} else {
				DYNAMIC_CUBE_MAP  = true;
			}
			break;
		case SDLK_F2:
			//MOTION BLUR
			if(MOTION_BLUR)
				MOTION_BLUR = false;
			else
				MOTION_BLUR = true;
			break;
		case SDLK_F3:
			//LENS FLARE
			if(LENS_FLARE)
				LENS_FLARE = false;
			else
				LENS_FLARE = true;
			break;
		case SDLK_F4:
			LAMP = LAMP ? false : true;
			break;
		case SDLK_1:
			macchina = changeCar(1);
			break;
		case SDLK_2:
			macchina = changeCar(2);
			break;
		case SDLK_3:
			macchina = changeCar(3);
			break;
		case SDLK_4:
			macchina = changeCar(4);
			break;
		case SDLK_5:
			macchina = changeCar(5);
			break;
		case SDLK_6:
			macchina = changeCar(6);
			break;
		case SDLK_7:
			macchina = changeCar(7);
			break;
		case SDLK_8:
			macchina = changeCar(8);
			break;
		case SDLK_r:
			macchina = updateCarDir();
			break;
	}
}

void keyup(SDL_Event e){
        switch (e.key.keysym.sym){
                case SDLK_w:
                        c_up = false;
                        break;
                case SDLK_s:
                        c_down = false;
                        break;
                case SDLK_d:
                        c_right = false;
                        break;
                case SDLK_a:
                        c_left = false;
                        break;
        }
}

int mipmaps = 1;
GLint viewport[4];

// RENDER-TO-TEXTURE
void RenderToTexture(GLenum target, GLuint texture, int side){
	// DIMENSIONE DELLA VIEWPORT - MI SERVE PER RIPRISTINARE LA VIEWPORT ALLA FINE
     glGetIntegerv(GL_VIEWPORT, viewport);
	 int width  = viewport[2];
	 int height = viewport[3];

	// RENDER SU TEXTURE 256X256 RGB
    char* buffer = new char[256*256*3];

	// GENERA IL NUMERO DELLA TEXTURE E LO METTE IN TEXTURE
    glGenTextures(1, &texture);
    glEnable(GL_TEXTURE_2D);

	// BINDA LA TEXTURE
    glBindTexture(target, texture);

	// PARAMTETRI
	glTexParameterf(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

	// TEXTURE
	if (mipmaps) {
		gluBuild2DMipmaps(target, GL_RGB, 256, 256, GL_RGB, GL_UNSIGNED_BYTE, buffer);
	} else {
		glTexImage2D(target, 0, GL_RGB, 256, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, buffer);
	}

    // CLEAR SCREEN
    glViewport(0, 0, 256, 256);
    //glClearColor(0.f, 0.f, 0.f, 0.f);
    //glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	//glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    // PUSH PROJECTION & MODELVIEW MATRICES
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
	glLoadIdentity();
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();
	
    // DRAW SCENE
	draw_scene(true,side);

	//glBindTexture(target, texture);

	// COPIA IL RENDERING DELLA SCENA SU UNA TEXTURE
    glCopyTexImage2D(target, 0, GL_RGB, 0, 0, 256, 256, 0);

    // RIPRISTINA LE MATRICI
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();
    glMatrixMode(GL_PROJECTION);
    glPopMatrix();

    // RIPRISTINO LE DIMENSIONI DELLA VIEWPORT
    glViewport(0, 0, width, height);

	// CLEAR
    //glClearColor(0.f, 0.f, 0.f, 0.f);
    //glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	//glClear(GL_DEPTH_BUFFER_BIT);
	glDisable(GL_TEXTURE_2D);
}

// TARGET PER CUBE MAPPING
GLuint cube_map_directions[6] = {
	GL_TEXTURE_CUBE_MAP_POSITIVE_X, 
	GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
	GL_TEXTURE_CUBE_MAP_POSITIVE_Y, 
	GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, 
	GL_TEXTURE_CUBE_MAP_POSITIVE_Z,
	GL_TEXTURE_CUBE_MAP_NEGATIVE_Z
};

// CUBE-MAP CON RENDER-TO-TEXTURE
void DynamicCubeMap(){
	int i=0;
	GLuint *texture;
	texture = (GLuint*)calloc(6, sizeof(GLuint));
	for(i=0;i<6;i++){
		// GLI PASSO IL TARGET SU CUI DEVE ATTACCARE LA TEXTURE, 
		// L'INDICE SU CUI BINDARE LA TEXTURE,
		// UN INTERO CHE MI SERVE PER IDENTIFICARE LA FACCIA DEL CUBO
		RenderToTexture(cube_map_directions[i], texture[i], i);
	}
}

// MOTION BLUR
float q = 0.8;
void motion_blur(){
	glAccum(GL_MULT, q);
	glAccum(GL_ACCUM, 1-q);
	glAccum(GL_RETURN, 1.0);
	glFlush();
}

int launch_viewer(){

  // inizializzazione di SDL  
  SDL_Init( SDL_INIT_VIDEO ); 
  
  // facciamo una finestra di 500x500
  SDL_SetVideoMode(800,600,0, SDL_OPENGL);

  //SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );

  glClearAccum(0.0, 0.0, 0.0, 1.0);
  glClear(GL_ACCUM_BUFFER_BIT);

  SDL_GL_SetAttribute(SDL_GL_ACCUM_RED_SIZE,16);
  SDL_GL_SetAttribute(SDL_GL_ACCUM_GREEN_SIZE,16);
  SDL_GL_SetAttribute(SDL_GL_ACCUM_BLUE_SIZE,16);
  SDL_GL_SetAttribute(SDL_GL_ACCUM_ALPHA_SIZE,16);

  bmin = race.circuit->bbox.min;
  bmax = race.circuit->bbox.max;

  // inizializzamo lo stato di opengl
  init_opengl();
  
  // inizializza i flares
  init_flares();

  // settiamo OpenGL alle dimensioni 500x500
  resize_screen(800,600);

  // faccio un refresh appena parto
  cli.Command(COMMAND_RESTART);

  static int last_rendering = 0;
  static int last_cubemapping = 0;
  static int last_blur = 0;
  static int freq = 0;
  int done=0;

  //pFile = fopen ("logfile.txt","w");

  while (!done) { // loop gestione eventi
    
    SDL_Event e;
 
		// guarda se c' un evento. Che ci sia o no continua
    if(SDL_PollEvent(&e))
			// processo l'evento
			switch (e.type) {
				case  SDL_MOUSEBUTTONDOWN: 
					// evento: il mouse si e' mosso
					mouse_BLDown = true ;
					break;
				case  SDL_MOUSEBUTTONUP: 
					// evento: il mouse si e' mosso
					mouse_BLDown = false ;
					break;
				case SDL_MOUSEMOTION: 
					// evento: il mouse si e' mosso
					mouse_move(e);
					break;
				case SDL_KEYDOWN: 
					keydown(e);
					break;
				case SDL_KEYUP: 
					keyup(e);
					break;
				case SDL_VIDEORESIZE:  
					// evento: a dim della finestra e' cambiata
					resize_screen(e.resize.w,e.resize.h);
					break;
				case SDL_QUIT:  
					// evento: la applicazione deve uscire
					done=1;   
					break;
				}

		/* temporizzazione del rendering: rendere il refresh machine independent*/
			if((clock()-last_cubemapping>30) && DYNAMIC_CUBE_MAP){
				DynamicCubeMap();
				last_cubemapping = clock();
			}
			if(clock()-last_rendering>15){
				draw_scene(false,0);
				last_rendering = clock();
			}

			if((clock()-last_blur>25) && MOTION_BLUR){
				motion_blur();
				last_blur = clock();
			}

			if(clock()-freq>20){
				freq = clock();
                if(c_up){
					cli.Command(COMMAND_INCREASE_SPEED);
				}
                if(c_down){
					cli.Command(COMMAND_DECREASE_SPEED);
				}
                if(c_left){
					cli.Command(COMMAND_TURN_LEFT);
				}
				if(c_right){
					cli.Command(COMMAND_TURN_RIGHT);
				}
			}
			
			SDL_GL_SwapBuffers();
  }

  //fclose (pFile);
	return 0;
}


