#include <iostream>
#include <vector>
#include <vcg/space/point3.h>
#include <vcg/space/box2.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include <GL/glu.h>
#include <SDL.h>
#include "tunnel.h"
#include "race.h"

// variabil globali
std::vector<Tunnel> allTunnels;
GLUquadricObj *qobj;
GLuint TunnelDL;

void loadTunnels(){
	size_t i=0, j=0, size=0;
	Tunnel mytunnel;
	Token myt;
	Street::TunnelsIterator t;
	GLfloat xmin,xmax,zmin,zmax;
	qobj=gluNewQuadric();
	// per ogni tunnel
	for(t=race.circuit->street.tunnels.begin();t!=race.circuit->street.tunnels.end();t++){
		// accedi alla sua  altezza
		mytunnel.height=t->heigth;
		// accedi alla sua base
		size=t->path.size();
		bool f=true;
		vcg::Point3f x[4];
		for(i=0;i<size-1;i++){
			x[0]=(t->path[i][0].P());
			x[1]=(t->path[i][1].P());
			x[2]=(t->path[i+1][0].P());
			x[3]=(t->path[i+1][1].P());
			if(f){
				xmin=x[0].X();xmax=x[0].X();
				zmin=x[0].Z();zmax=x[0].Z();
				f=false;
			}
			// calcolo bbox tunnel
			for(j=0;j<4;j++){
				if(xmin>x[j].X())xmin=x[j].X();
				if(xmax<x[j].X())xmax=x[j].X();
				if(zmin>x[j].Z())zmin=x[j].Z();
				if(zmax<x[j].Z())zmax=x[j].Z();
			}
			// calcolo il centro
			myt.pivot=x[0];
			// calcolo frame di vista per il token del tunnel
			myt.b=(x[1]-x[0]).Norm();
			myt.d=(x[2]-x[0]).Norm();
			myt.bbox.Add(vcg::Point2f(x[0].X(),x[0].Z()));
			myt.bbox.Add(vcg::Point2f(x[1].X(),x[1].Z()));
			myt.bbox.Add(vcg::Point2f(x[2].X(),x[2].Z()));
			myt.bbox.Add(vcg::Point2f(x[3].X(),x[3].Z()));
			myt.x=(x[1]-x[0]).Normalize();
			myt.z=(x[2]-x[0]).Normalize();
			mytunnel.footprint.push_back(myt);
			myt.bbox.SetNull();
		}
		mytunnel.bbox.Add(vcg::Point2f(xmin,zmin));
		mytunnel.bbox.Add(vcg::Point2f(xmax,zmax));
		allTunnels.push_back(mytunnel);
		mytunnel.footprint.clear();
		mytunnel.bbox.SetNull();
	}
}

void drawToken(Token* t, float height){
	glEnable(GL_TEXTURE_2D);
	glMateriali(GL_FRONT, GL_SHININESS, 0.1);
	vcg::Matrix44f m;
	m.SetIdentity();
	m[0][0]=t->x[0];m[0][1]=0.0;m[0][2]=t->z[0];
	m[1][0]=t->x[1];m[1][1]=1.0;m[1][2]=t->z[1];
	m[2][0]=t->x[2];m[2][1]=0.0;m[2][2]=t->z[2];
	m=vcg::Transpose(m);
	// disegno il token del tunnel
	glPushMatrix();
	glTranslatef(t->pivot.X(),t->pivot.Y(),t->pivot.Z());
	glMultMatrixf(&m[0][0]);
	glBindTexture(GL_TEXTURE_2D,5);
	glBegin(GL_QUADS);
	glNormal3f(1,0,0);
	glTexCoord2f(0.0,0.0);glVertex3f(0.0,-0.45,0.0);
	glTexCoord2f(1.0,0.0);glVertex3f(0.0,height,0.0);
	glTexCoord2f(1.0,1.0);glVertex3f(0.0,height,t->d);
	glTexCoord2f(0.0,1.0);glVertex3f(0.0,-0.45,t->d);
	glEnd();
	glBegin(GL_QUADS);
	glNormal3f(-1,0,0);
	glTexCoord2f(0.0,0.0);glVertex3f(t->b,-0.45,0.0);
	glTexCoord2f(1.0,0.0);glVertex3f(t->b,height,0.0);
	glTexCoord2f(1.0,1.0);glVertex3f(t->b,height,t->d);
	glTexCoord2f(0.0,1.0);glVertex3f(t->b,-0.45,t->d);
	glEnd();
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
	glBindTexture(GL_TEXTURE_2D,6);
	glBegin(GL_QUADS);
	glNormal3f(0,-1,0);
	glTexCoord2f(0.0,0.0);glVertex3f(0.0,height,0.0);
	glTexCoord2f(1.0,0.0);glVertex3f(0.0,height,t->d);
	glTexCoord2f(1.0,1.0);glVertex3f(t->b,height,t->d);
	glTexCoord2f(0.0,1.0);glVertex3f(t->b,height,0.0);
	glEnd();
	glPopMatrix();
	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
}

void drawTunnel(std::vector<Tunnel>::iterator t, vcg::Point3f &pov, vcg::Point3f &pov2){
	// vcg::Point3f vd=(pov2-pov).Normalize();
	// disegno il tunnel
	size_t i=0,s=t->footprint.size();
	for(i=0;i<s;i++){
		//t->footprint[i].
		/*vcg::Point3f a=t->footprint[i].center-pov;
		float cos1=(vd*a.Normalize());
		float d=a.Norm();
		if(d<t->footprint[i].d || (cos1>=0 && d<700))*/
			drawToken(&t->footprint[i],t->height);
	}
}

void drawTunnels(vcg::Point3f &position, vcg::Point3f &pov, vcg::Point3f &pov2){
	bool r=false,b=false;
	//vcg::Point2f np(pov.X(),pov.Z());
	vcg::Point2f P(position.X(),position.Z());
	//vcg::Point2f vd=(vcg::Point2f(pov2.X(),pov2.Z())-np).Normalize();
	// disegno i tunnels
	std::vector<Tunnel>::iterator t;
	for(t=allTunnels.begin();t!=allTunnels.end();t++){
		/*vcg::Point2f a=t->bbox.Center()-np;
		float cos1=(vd*a.Normalize());
		float d=a.Norm();*/
		b=t->bbox.IsIn(P);
		if(b)r=true;
		//if(b || (cos1>=0 && d<700))
			drawTunnel(t,pov,pov2);
	}
	//return r;
}

bool IsInTunnel(vcg::Point3f &position){
	bool b=false,r=false;
	std::vector<Tunnel>::iterator t;
	vcg::Point2f P(position.X(),position.Z());
	for(t=allTunnels.begin();t!=allTunnels.end();t++){
		b=t->bbox.IsIn(P);
		if(b){
			size_t i=0,s=t->footprint.size();
			for(i=0;i<s;i++)
				if(t->footprint[i].bbox.IsIn(P)){
					r=true;
					break;
				}
		}
		if(r)break;
	}
	return r;
}
