#ifndef _NVMC_FRAME_
#define _NVMC_FRAME_
/****************************************************************************
* NVMC                                                                      *
* Visual and Computer Graphics Library                                      *
*                                                                           *
* Copyright(C) 2007                                                         *
* ISTI - Italian National Research Council                                  *
*                                                                           *
* All rights reserved.                                                      *
*                                                                           *
* This program is free software; you can redistribute it and/or modify      *   
* it under the terms of the GNU General Public License as published by      *
* the Free Software Foundation; either version 2 of the License, or         *
* (at your option) any later version.                                       *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License (http://www.gnu.org/licenses/gpl.txt)          *
* for more details.                                                         *
*                                                                           *
****************************************************************************/
/****************************************************************************
  History

$Log: frame.h,v $
Revision 1.4  2007/03/21 10:34:22  ganovelli
added better steering,

Revision 1.3  2007/03/17 12:26:14  ganovelli
* pragma replaced by #ifndef directive
* Player operator= added
* bug in race_simulation.cpp corrected
* msvc2005 solutions added

Revision 1.2  2007/03/11 15:08:52  ganovelli
*** empty log message ***

Revision 1.1  2007/03/10 16:43:35  ganovelli
first working draft



*****************************************************************************/

#include <vcg/math/Matrix44.h>

/// the reference system of the car
class Frame: public vcg::Matrix44f{

public:
	/** transforms a point from word coordinates to this frame coordinates**/ 
	vcg::Point3f FromWordCoord(vcg::Point3f p){}

	/** transforms a point from this frame coordinates to the world coordinates**/ 
	vcg::Point3f ToWordCoord(vcg::Point3f p){}

	/** transforms a point from the passed frame coordinates to this frame coordinates**/ 
	vcg::Point3f FromFrameCoord(vcg::Point3f p){}

	/** transforms a point from this frame coordinates to the world coordinates**/ 
	vcg::Point3f ToFrameCoord(vcg::Point3f p){}

	/** origin of the frame **/
	vcg::Point4f & O(){ return *(vcg::Point4f*)&(*this)[3][0];}

	/** axis 0=x, 1=y, 2=z **/
	vcg::Point4f & Axis(const int & i){ assert(i>=0); assert(i<3); return *(vcg::Point4f*)&(*this)[i][0];}
};
#endif
